<?xml version="1.0" encoding="UTF-8"?>
<ecore:EPackage xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
    xmlns:ecore="http://www.eclipse.org/emf/2002/Ecore" name="ra" nsURI="platform:/plugin/tdt4250.ra/model/ra.ecore" nsPrefix="ra">
  <eAnnotations source="http://www.eclipse.org/emf/2002/Ecore">
    <details key="validationDelegates" value="http://www.eclipse.org/acceleo/query/1.0"/>
  </eAnnotations>
  <eClassifiers xsi:type="ecore:EClass" name="Department">
    <eOperations name="allocateStaffToCourse">
      <eParameters name="person" lowerBound="1" eType="#//Person"/>
      <eParameters name="course" lowerBound="1" eType="#//Course"/>
      <eParameters name="factor" lowerBound="1" eType="ecore:EDataType http://www.eclipse.org/emf/2002/Ecore#//EFloat"/>
    </eOperations>
    <eStructuralFeatures xsi:type="ecore:EAttribute" name="name" eType="ecore:EDataType http://www.eclipse.org/emf/2002/Ecore#//EString"/>
    <eStructuralFeatures xsi:type="ecore:EAttribute" name="shortName" eType="ecore:EDataType http://www.eclipse.org/emf/2002/Ecore#//EString"/>
    <eStructuralFeatures xsi:type="ecore:EReference" name="staff" upperBound="-1"
        eType="#//Person" containment="true" eOpposite="#//Person/employer"/>
    <eStructuralFeatures xsi:type="ecore:EReference" name="courses" upperBound="-1"
        eType="#//Course" containment="true" eKeys="#//Course/code"/>
    <eStructuralFeatures xsi:type="ecore:EReference" name="resourceAllocations" upperBound="-1"
        eType="#//ResourceAllocation" containment="true"/>
  </eClassifiers>
  <eClassifiers xsi:type="ecore:EClass" name="Course">
    <eAnnotations source="http://www.eclipse.org/emf/2002/Ecore">
      <details key="constraints" value="courseShouldntHaveTooLittleStaff"/>
    </eAnnotations>
    <eAnnotations source="http://www.eclipse.org/acceleo/query/1.0">
      <details key="courseShouldntHaveTooLittleStaff" value="self.allocations.factor->sum() >= 0.8"/>
    </eAnnotations>
    <eStructuralFeatures xsi:type="ecore:EAttribute" name="code" eType="ecore:EDataType http://www.eclipse.org/emf/2002/Ecore#//EString"/>
    <eStructuralFeatures xsi:type="ecore:EAttribute" name="name" eType="ecore:EDataType http://www.eclipse.org/emf/2002/Ecore#//EString"/>
    <eStructuralFeatures xsi:type="ecore:EReference" name="allocations" upperBound="-1"
        eType="#//ResourceAllocation" eOpposite="#//ResourceAllocation/course"/>
    <eStructuralFeatures xsi:type="ecore:EReference" name="roles" upperBound="-1"
        eType="#//Role" containment="true" eOpposite="#//Role/course"/>
  </eClassifiers>
  <eClassifiers xsi:type="ecore:EClass" name="Role">
    <eStructuralFeatures xsi:type="ecore:EReference" name="course" eType="#//Course"
        eOpposite="#//Course/roles"/>
    <eStructuralFeatures xsi:type="ecore:EAttribute" name="name" eType="ecore:EDataType http://www.eclipse.org/emf/2002/Ecore#//EString"/>
    <eStructuralFeatures xsi:type="ecore:EAttribute" name="workload" eType="ecore:EDataType http://www.eclipse.org/emf/2002/Ecore#//EFloat"/>
  </eClassifiers>
  <eClassifiers xsi:type="ecore:EClass" name="Person">
    <eAnnotations source="http://www.eclipse.org/emf/2002/Ecore">
      <details key="constraints" value="personShouldntHaveTooMuchToDo"/>
    </eAnnotations>
    <eStructuralFeatures xsi:type="ecore:EAttribute" name="name" eType="ecore:EDataType http://www.eclipse.org/emf/2002/Ecore#//EString"/>
    <eStructuralFeatures xsi:type="ecore:EReference" name="employer" eType="#//Department"
        eOpposite="#//Department/staff"/>
    <eStructuralFeatures xsi:type="ecore:EReference" name="allocations" upperBound="-1"
        eType="#//ResourceAllocation" eOpposite="#//ResourceAllocation/person"/>
    <eStructuralFeatures xsi:type="ecore:EAttribute" name="workload" eType="ecore:EDataType http://www.eclipse.org/emf/2002/Ecore#//EFloat"
        changeable="false" volatile="true" transient="true" derived="true"/>
  </eClassifiers>
  <eClassifiers xsi:type="ecore:EClass" name="ResourceAllocation">
    <eAnnotations source="http://www.eclipse.org/emf/2002/Ecore">
      <details key="constraints" value="roleMustBeForSameCourse"/>
    </eAnnotations>
    <eStructuralFeatures xsi:type="ecore:EReference" name="person" eType="#//Person"
        eOpposite="#//Person/allocations" eKeys="#//Person/name"/>
    <eStructuralFeatures xsi:type="ecore:EReference" name="course" eType="#//Course"
        eOpposite="#//Course/allocations"/>
    <eStructuralFeatures xsi:type="ecore:EReference" name="role" eType="#//Role"/>
    <eStructuralFeatures xsi:type="ecore:EAttribute" name="factor" eType="ecore:EDataType http://www.eclipse.org/emf/2002/Ecore#//EFloat"/>
    <eStructuralFeatures xsi:type="ecore:EAttribute" name="workload" eType="ecore:EDataType http://www.eclipse.org/emf/2002/Ecore#//EFloat"
        changeable="false" volatile="true" transient="true" derived="true"/>
  </eClassifiers>
</ecore:EPackage>
